Capitalist = LibStub("AceAddon-3.0"):NewAddon("Capitalist", "AceEvent-3.0", "AceConsole-3.0")
Capitalist.Locals = {}
local L = Capitalist.Locals

function Capitalist:OnInitialize()
	self.updateHandler = CreateFrame("frame")
	self.updateHandler:Hide()
	self.elapsed = 0
	self.updateHandler:SetScript("OnUpdate", function(self, elapsed)
												self = Capitalist
												self.elapsed = self.elapsed + elapsed
--self:Print("OnUpdate")
--self:Print(self.mode)
												
												if (self.mode == "scanning") then
													self:OnUpdateScanning()
												elseif (self.mode == "posting") then
													self:OnUpdatePosting()
												elseif (self.mode == "reagentsearching") then
													self:OnUpdateReagentSearching()
												else
													self:OnUpdateReagentScanning()
												end
											end)
	
	
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("AUCTION_HOUSE_SHOW")
	self:RegisterEvent("AUCTION_OWNED_LIST_UPDATE")
	self:RegisterEvent("BAG_UPDATE")
	self:RegisterEvent("CHAT_MSG_LOOT")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	self:RegisterEvent("UI_ERROR_MESSAGE")
	self:RegisterEvent("AUCTION_HOUSE_CLOSED")
	self:RegisterEvent("BANKFRAME_OPENED")
	self:RegisterEvent("BANKFRAME_CLOSED")
	
	
	if (IsAddOnLoaded("Blizzard_AuctionUI")) then
		self:ADDON_LOADED("ADDON_LOADED", "Blizzard_AuctionUI")
	end
	if (IsAddOnLoaded("Blizzard_TradeSkillUI")) then
		self:ADDON_LOADED("ADDON_LOADED", "Blizzard_TradeSkillUI")
	end

	local defaults = {
			profile = {
				version = 1.32,
			
				margin = 100,
				minMargin = 100*10000,
				maxMargin = 300*10000,
				minProfit = 0*10000,
				showByDefault = false,
				cancelYellow = true,
				cancelblue = true,
				cancelDuration = true,
				
				storage = {
				
				},
				
				filters = {
					global = {
						Northrend = true,
						BurningCrusade = false,
						Classic = false,
					},
				},
				
				recipes = {
				
				},
				
				reagents = {
				
				},
			}
		}
	self.db = LibStub("AceDB-3.0"):New("CapitalistDB", defaults, true)
	
	if (not self.db.profile.storage[GetCVar("realmName")]) then
		self.db.profile.storage[GetCVar("realmName")] = {}
	end
	
	if (not self.db.profile.storage[GetCVar("realmName")][UnitName("player")]) then
		self.db.profile.storage[GetCVar("realmName")][UnitName("player")] = {AH = {}, inventory = {}}
	end
	
	if (not self.db.profile.version or self.db.profile.version < 1.3) then
		if (self.db.profile.prices) then -- pre 1.3 beta
			-- reset the db. screw the data loss, make a better design next time
			self.db = defaults
		end
	end
	
	-- convert from 1.3 to 1.3.2
	for k, v in pairs(self.db.profile.recipes) do
		if (self.db.profile.recipes[k].numCreated == nil) then
			self.db.profile.recipes[k].numCreated = 0
		end
	end
	
	-- convert from 1.3.2 to 1.4
	if (self.db.profile.scrolls) then
		self.db.profile.storage = self.db.profile.scrolls
		self.db.profile.scrolls = nil
	end
	for server in pairs(self.db.profile.storage) do
		for player, data in pairs(self.db.profile.storage[server]) do
			if (not data.bank) then
				self.db.profile.storage[server][player].bank = {}
			end
		end
	end
	
	self.db.profile.version = defaults.profile.version
	
	self:BuildList()
	self:BuildOptions()
end

function Capitalist:ADDON_LOADED(event, addon)
	if (addon == "Blizzard_AuctionUI") then
		self:CreateAuctionUI()
		self:CreateReagentUI()
		if (self.db.profile.showByDefault) then
			self:ToggleAuctionUI()
		end
	end
	if (addon == "Blizzard_TradeSkillUI") then
		self.restockButton = CreateFrame("button", "CapitalistRestockButton", TradeSkillFrame, "UIPanelButtonTemplate")
		self.restockButton:SetPoint("TOPRIGHT", TradeSkillFrame, "TOPRIGHT", -25, -2)
		self.restockButton:SetHeight(17)
		self.restockButton:SetWidth(60)
		self.restockButton:SetText("(C)")
		self.restockButton:SetScript("OnClick", function() Capitalist:Restock() end)
		self.restockButton:Show()

		self.showStackButton = CreateFrame("button", "CapitalistShowStackButton", TradeSkillFrame, "UIPanelButtonTemplate")
		self.showStackButton:SetPoint("TOPRIGHT", self.restockButton, "TOPLEFT", 0, 0)
		self.showStackButton:SetHeight(17)
		self.showStackButton:SetWidth(30)
		self.showStackButton:SetText("(R)")
		self.showStackButton:SetScript("OnClick", function() Capitalist:ShowRestockStack() end)
		self.showStackButton:Show()
		
		self.TradeSkillFrame_Show_Hook = TradeSkillFrame_Show
		TradeSkillFrame_Show =  function()
									Capitalist.TradeSkillFrame_Show_Hook()
									if (CURRENT_TRADESKILL == L["Enchanting"]) then
										self.restockButton:Show()
										self.showStackButton:Show()
										self:ScanTradeSkillFrame()
									else
										self.restockButton:Hide()
										self.showStackButton:Hide()
									end
								end
									
	end
end

function Capitalist:AUCTION_HOUSE_CLOSED()
	if (self.updateHandler:IsVisible()) then
		self.updateHandler:Hide()
		
		if (self.mode == "scanning") then
			self.auctionUI.lastScanLabel:SetText(L["Last Scan: failed"])
			self.auctionUI.lastScanLabel:Show()
			self.auctionUI.progress:Hide()
			self.auctionUI.progressLabel:Hide()
			self.auctionUI.scanButton:Enable()
			self.validScan = false
		end
	end
end

function Capitalist:HandleSlashCommand(input)
	if (input == "restock") then
		if (not (CURRENT_TRADESKILL == L["Enchanting"] and TradeSkillFrame:IsVisible())) then
			CastSpellByName(L["Enchanting"])
		else
			self:Restock()
		end
	else
		InterfaceOptionsFrame_OpenToCategory("Capitalist")
	end
end