local L = Capitalist.Locals

if GetLocale() then
	L["Enchanting"] = "Enchanting"

	L["Dust"] = "Dust"
	L["Essence"] = "Essence"
	L["Shard"] = "Shard"
	L["Crystal"] = "Crystal"
	
	L["Enchanting Vellum"] = "Enchanting Vellum"
	
	L["Scroll of Enchant"] = "Scroll of Enchant"
	L["You create:"] = "You create:"
	L["Inventory is full."] = "Inventory is full."
	
	L["scanning.."] = "scanning.."
	L["Last Scan: "] = "Last Scan: "
	L["Last Scan: failed"] = "Last Scan: failed"
	L["perform scan"] = "perform scan"
	
	L["cancel auctions"] = "cancel auctions"
	L["post scrolls"] = "post scrolls"
	
	L["cancel yellow auctions"] = "cancel yellow auctions"
	L["cancel blue auctions"] = "cancel blue auctions"
	L["cancel auctions that expire in 12h"] = "cancel auctions that expire in 12h"
	
	L["Nothing to restock!"] = "Nothing to restock!"
	L["Need to restock %d scrolls:"] = "Need to restock %d scrolls:"
	L["Could not restock anything!"] = "Could not restock anything!"
	
	L["Missing reagents:"] = "Missing reagents:"
	L["Everything available!"] = "Everything available!"

	L["General options"] = "General options"
	
	L["Auction house character"] = "Auction house character"
	L["The name of the character that you do all the Auction House stuff with (optional)"] = "The name of the character that you do all the Auction House stuff with (optional)"
	
	L["Auto-send scrolls to this character"] = "Auto-send scrolls to this character"
	L["If checked, will automatically send scrolls from your inventory to your auction house character when you enter a mailbox"] = "If checked, will automatically send scrolls from your inventory to your auction house character when you enter a mailbox"
	
	L["Show by default"] = "Show by default"
	L["Automatically opens Capitalist when you enter the Auction House"] = "Automatically opens Capitalist when you enter the Auction House"
	
	L["Scroll count (general)"] = "Scroll count (general)"
	L["Defines, how many scrolls of the same type need to be at the Auction House at the same time at minimum. Overrides your individual settings!"] = "Defines, how many scrolls of the same type need to be at the Auction House at the same time at minimum. Overrides your individual settings!"
	
	L["Post no more than this amount of items"] = "Post no more than this amount of items"
	L["If you have more of a scroll than the scroll count suggests, don't post the excess ones."] = "If you have more of a scroll than the scroll count suggests, don't post the excess ones."
	
	L["Minimal profit"] = "Minimal profit"
	L["How much you want to gain at minimum from each scroll (price is simply added to material cost)."] = "How much you want to gain at minimum from each scroll (price is simply added to material cost)."
	
	L["Price margin"] = "Price margin"
	L["The increase (in percent) in price, if there is no or very expensive competition."] = "The increase (in percent) in price, if there is no or very expensive competition."
	
	L["Minimal increase"] = "Minimal increase"
	L["How much (in gold) the price should increase at minimum if there is no or very expensive competition."] = "How much (in gold) the price should increase at minimum if there is no or very expensive competition."
	
	L["Maximal increase"] = "Maximal increase"
	L["How much (in gold) the price should increase at maximum if there is no or very expensive competition."] = "How much (in gold) the price should increase at maximum if there is no or very expensive competition."
	
	L["Northrend"] = "Northrend"
	L["If checked, enchants using Northrend reagents will be produced"] = "If checked, enchants using Northrend reagents will be produced"
	
	L["Burning Crusade"] = "Burning Crusade"
	L["If checked, enchants using Burning Crusade reagents will be produced"] = "If checked, enchants using Burning Crusade reagents will be produced"
	
	L["Classic"] = "Classic"
	L["If checked, enchants using Classic reagents will be produced"] = "If checked, enchants using Classic reagents will be produced"
	
	L["Scroll Filters"] = "Scroll Filters"
	L["all scrolls"] = "all scrolls"
	L["enable or disable all scrolls"] = "enable or disable all scrolls"
	
	L["Reagent Prices"] = "Reagent Prices"
	L["Set the price of %s in gold"] = "Set the price of %s in gold"
	
	L["Scroll Count"] = "Scroll Count"
	
	L["Created Scrolls"] = "Created Scrolls"


	
	L.getAppropriateVellum = 	function(name, desc)		
--brian
return L["Enchanting Vellum"]
--									-- given a skill name and description, this
--									local appendix										-- function returns the name of the appropriate vellum
--									if (desc:find("Requires a level 60 or higher item.") or
--										desc:find("Requires a level 60 or higher level item.") or
--										desc:find("This enchantment requires the wielder is at least level 75.")) then
--										appendix = " III"
--									elseif (desc:find("Requires a level 35 or higher item.")) then
--										appendix = " II"
--									else
--										appendix = ""
--									end
--									
--									if (name:find("Weapon") or name:find("Staff")) then
--										return L["Weapon Vellum"]..appendix
--									else
--										return L["Armor Vellum"]..appendix
--									end
								end
	
	L.checkForValidSkillName = 	function(name)
									local slot = name:match("Enchant ([%a2 ]+)-.+")		-- validates if the string has the form
									return slot and slot ~= "Ring "						-- "Enchant XY - Z" (with XY != Ring)
								end													
	L.stripSkillName 		= 	function(name)
									return name:match("Enchant ([%a2 ]+-.+)")			-- strips "Enchant" from the skill name
								end

	L.getScrollName			=	function(name)
									name = "Scroll of "..name							-- returns the name of the corresponding scroll for an enchant
									if (name:find("Bracer")) then						
										if (name:find("Striking") or name:find("Major Spirit") or name:find("Major Healing") or
											name:find("Greater Stats") or name:find("Greater Spellpower") or name:find("Greater Assault") or
											name:find("Exceptional Intellect")) then
											name = name:gsub("Bracer ", "Bracers ") -- wth, Blizzard, what the hell
										else
											name = name:gsub("Bracers ", "Bracer ")
										end
									end
									return name
								end
									
end