local L = Capitalist.Locals

function Capitalist:CreateAuctionUI()
	self.auctionUIButton = CreateFrame("button", nil, AuctionFrameBrowse)
	local t = self.auctionUIButton
	t:SetPoint("TOPLEFT", AuctionFrame, "TOPLEFT", 20, -70)
	t:SetHeight(30)
	t:SetWidth(30)
	t:SetScript("OnClick", function() Capitalist:ToggleAuctionUI() end)
	t:Show()
	
	t.texture = t:CreateTexture()
	t.texture:SetAllPoints()
	t.texture:SetTexture("Interface\\Icons\\INV_Scroll_03")
	t.texture:SetDrawLayer("BACKGROUND")
	
	t.border = t:CreateTexture()
	t.border:SetAllPoints()
	t.border:SetTexture("Interface\\Buttons\\ButtonHilight-Square")
	t.border:SetBlendMode("ADD")
	t.border:SetDrawLayer("BORDER")
	t.border:Hide()
	t:SetScript("OnEnter", function(self) self.border:Show() end)
	t:SetScript("OnLeave", function(self) if (not Capitalist.auctionUI:IsVisible()) then self.border:Hide() end end)
	
	
	
	
	self.auctionUI = CreateFrame("frame", nil, AuctionFrameBrowse)
	t = self.auctionUI
	t:SetPoint("TOPLEFT", AuctionFrame, "TOPLEFT", 16, -101)
	t:SetPoint("BOTTOMRIGHT", AuctionFrame, "BOTTOMRIGHT", -7, 37)
	t:SetFrameStrata("HIGH")
	t:EnableMouse(true)
	t:Hide()
	
	t.background = t:CreateTexture(nil, "BACKGROUND")
	t.background:SetAllPoints()
	t.background:SetTexture(0,0,0)
	
	t.lastScanLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.lastScanLabel:SetText(L["Last Scan: "].."-")
	t.lastScanLabel:SetPoint("TOPLEFT", 10, -10)
	t.lastScanLabel:SetWidth(110)
	t.lastScanLabel:SetHeight(20)

	t.progress = t:CreateTexture()
	t.progress:SetPoint("LEFT", t.lastScanLabel, "LEFT")
	t.progress:SetWidth(110)
	t.progress:SetHeight(20)
	t.progress:SetTexture(0, 0, 1)
	t.progress:Hide()
	
	t.progressLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.progressLabel:SetAllPoints(t.lastScanLabel)
	
	t.scanButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.scanButton:SetWidth(110)
	t.scanButton:SetHeight(20)
	t.scanButton:SetPoint("TOPLEFT", t.lastScanLabel, "BOTTOMLEFT", 0, -5)
	t.scanButton:SetText(L["perform scan"])
	t.scanButton:SetScript("OnClick", function() Capitalist:StartScan() end)

	t.cancelButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.cancelButton:SetWidth(110)
	t.cancelButton:SetHeight(20)
	t.cancelButton:SetPoint("TOPLEFT", t.scanButton, "BOTTOMLEFT", 0, -5)
	t.cancelButton:SetText(L["cancel auctions"])
	t.cancelButton:SetScript("OnClick", function() Capitalist:CancelAuctions() end)
	t.cancelButton:Disable()

	t.postButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.postButton:SetWidth(110)
	t.postButton:SetHeight(20)
	t.postButton:SetPoint("TOPLEFT", t.cancelButton, "BOTTOMLEFT", 0, -5)
	t.postButton:SetText(L["post scrolls"])
	t.postButton:SetScript("OnClick", function() Capitalist:StartPost() end)
	t.postButton:Disable()
	
	t.items = {}
	for i = 1, 13 do
		t.items[i] = CreateFrame("frame", nil, t)
		local item = t.items[i]
		item:SetWidth(500)
		item:SetHeight(20)
		item:SetPoint("TOPLEFT", t, "TOPLEFT", 250, -20*i)
		
		item.name = item:CreateFontString(nil, nil, "GameFontNormal")
		item.name:SetWidth(250)
		item.name:SetPoint("TOPLEFT")
		item.name:SetText("")
		item.name:SetJustifyH("LEFT")
		
		item.money = item:CreateFontString(nil, nil, "GameFontNormal")
		item.money:SetWidth(180)
		item.money:SetPoint("LEFT", item.name, "RIGHT")
		item.money:SetText("")
		item.money:SetJustifyH("LEFT")
		
		item.count = item:CreateFontString(nil, nil, "GameFontNormal")
		item.count:SetPoint("LEFT", item.money, "RIGHT")
		item.count:SetWidth(100)
		item.count:SetText("")
	end
	
	t.page = 0
	
	t.prevButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.prevButton:SetWidth(30)
	t.prevButton:SetHeight(20)
	t.prevButton:SetText("<<")
	t.prevButton:SetPoint("TOPLEFT", t.items[13], "BOTTOMLEFT")
	t.prevButton:SetScript("OnClick", function()
										local i = Capitalist.auctionUI.page
										if (i > 0) then i = i - 1 end
										Capitalist.auctionUI.page = i
										Capitalist:UpdateAuctionUI()
									  end)
	t.prevButton:Disable()
	
	t.nextButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.nextButton:SetWidth(30)
	t.nextButton:SetHeight(20)
	t.nextButton:SetText(">>")
	t.nextButton:SetPoint("LEFT", t.prevButton, "RIGHT", 10, 0)
	t.nextButton:SetScript("OnClick", function()
									Capitalist.auctionUI.page = Capitalist.auctionUI.page + 1
									Capitalist:UpdateAuctionUI()
								  end)
	t.nextButton:Disable()
	
	t.cancelYellow = CreateFrame("CheckButton", nil, t, "UICheckButtonTemplate")
	t.cancelYellow:SetPoint("TOPLEFT", t.postButton, "BOTTOMLEFT", 0, -10)
	t.cancelYellow:SetScale(0.6)
	t.cancelYellow:SetChecked(self.db.profile.cancelYellow)
	t.cancelYellow:SetScript("OnClick", function(self)
											Capitalist.db.profile.cancelYellow = self:GetChecked() == 1
											Capitalist:CheckForCancel()
										end)
	
	t.cancelYellowLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.cancelYellowLabel:SetPoint("LEFT", t.cancelYellow, "RIGHT")
	t.cancelYellowLabel:SetJustifyH("LEFT")
	t.cancelYellowLabel:SetText(L["cancel yellow auctions"])

	t.cancelblue = CreateFrame("CheckButton", nil, t, "UICheckButtonTemplate")
	t.cancelblue:SetPoint("TOPLEFT", t.cancelYellow, "BOTTOMLEFT", 0, 5)
	t.cancelblue:SetScale(0.6)
	t.cancelblue:SetChecked(self.db.profile.cancelblue)
	t.cancelblue:SetScript("OnClick", function(self)
											Capitalist.db.profile.cancelblue = self:GetChecked() == 1
											Capitalist:CheckForCancel()
										end)
	
	t.cancelblueLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.cancelblueLabel:SetPoint("LEFT", t.cancelblue, "RIGHT")
	t.cancelblueLabel:SetJustifyH("LEFT")
	t.cancelblueLabel:SetText(L["cancel blue auctions"])

	t.cancelDuration = CreateFrame("CheckButton", nil, t, "UICheckButtonTemplate")
	t.cancelDuration:SetPoint("TOPLEFT", t.cancelblue, "BOTTOMLEFT", 0, 5)
	t.cancelDuration:SetScale(0.6)
	t.cancelDuration:SetChecked(self.db.profile.cancelDuration)
	t.cancelDuration:SetScript("OnClick", function(self)
											Capitalist.db.profile.cancelDuration = self:GetChecked() == 1
											Capitalist:CheckForCancel()
										end)
	
	t.cancelDurationLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.cancelDurationLabel:SetPoint("LEFT", t.cancelDuration, "RIGHT")
	t.cancelDurationLabel:SetJustifyH("LEFT")
	t.cancelDurationLabel:SetText(L["cancel auctions that expire in 12h"])

	t.grayLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.grayLabel:SetPoint("TOPLEFT", t.postButton, "BOTTOMLEFT", 0, -120)
	t.grayLabel:SetTextColor(0.7, 0.7, 0.7)
	
	t.greenLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.greenLabel:SetPoint("TOPLEFT", t.grayLabel, "BOTTOMLEFT")
	t.greenLabel:SetTextColor(0, 1, 0)	
	
	t.yellowLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.yellowLabel:SetPoint("TOPLEFT", t.greenLabel, "BOTTOMLEFT")
	t.yellowLabel:SetTextColor(1, 1, 0)	
	
	t.orangeLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.orangeLabel:SetPoint("TOPLEFT", t.yellowLabel, "BOTTOMLEFT")
	t.orangeLabel:SetTextColor(1, 0.5, 0)	
	
	t.blueLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.blueLabel:SetPoint("TOPLEFT", t.orangeLabel, "BOTTOMLEFT")
	t.blueLabel:SetTextColor(0.4, 0.4, 1)	

	t.redLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.redLabel:SetPoint("TOPLEFT", t.blueLabel, "BOTTOMLEFT")
	t.redLabel:SetTextColor(1, 0, 0)		

end

function Capitalist:ToggleAuctionUI()
	if (self.reagentUI:IsVisible()) then
		self:ToggleReagentUI()
	end

	if (self.auctionUI:IsVisible()) then
		self.auctionUI:Hide()
		self.auctionUIButton.border:Hide()
		
		BrowseQualitySort:Show()
		BrowseLevelSort:Show()
		BrowseDurationSort:Show()
		BrowseHighBidderSort:Show()
		BrowseCurrentBidSort:Show()
	else
		self.auctionUI:Show()
		self.auctionUIButton.border:Show()
		
		BrowseQualitySort:Hide()
		BrowseLevelSort:Hide()
		BrowseDurationSort:Hide()
		BrowseHighBidderSort:Hide()
		BrowseCurrentBidSort:Hide()
	end
end

function Capitalist:AUCTION_HOUSE_SHOW()
	self:UpdateRestockStack()
	self:UpdateAuctionUI()
	self:UpdateReagentUI()
end

function Capitalist:AUCTION_OWNED_LIST_UPDATE()
	self:UpdateAuctionUI()
end

function Capitalist:UpdateAuctionUI()
	-- save, which scrolls are on the AH (for restocking)
	local scrollsInAH = self.db.profile.storage[GetCVar("realmName")][UnitName("player")].AH
	for k, v in pairs(scrollsInAH) do scrollsInAH[k] = nil end
	
	for i = 1, GetNumAuctionItems("owner") do
		local name, _, _, _, _, _, _, _, buyoutPrice, _, _, _, saleStatus = GetAuctionItemInfo("owner", i)
		if (self.list[name] and saleStatus == 0) then
			if (not scrollsInAH[name]) then
				scrollsInAH[name] = 1
			else
				scrollsInAH[name] = scrollsInAH[name] + 1
			end
		end
	end
	
	local auctionInfo = {}
	local numAuctionTypes = {gray = 0, green = 0, yellow = 0, orange = 0, blue = 0, red = 0}	
	
	for recipe, data in pairs(self.db.profile.recipes) do
		if (data.isUsed == true and data.isFiltered == false and data.scrollCount > 0) then
			local type = "gray"
			
			if (not scrollsInAH[data.scrollName]) then
				-- we don't have that scroll on the AH - restock it
				type = "red"
			elseif (self.validScan) then
				local v = self.list[data.scrollName]
				
				if (v.buyoutOthers == nil or v.buyoutSelf < v.buyoutOthers) then
					-- we have the cheapest auction of that type on the AH
					type = "green"
				elseif (v.buyoutOthers < v.bestPrice) then
					-- we can't undercut the cheapest auction
					type = "orange"
				elseif (v.buyoutSelf < v.bestPrice) then
					-- we can re-post for a higher price
					type = "blue"
				elseif (v.bestPrice < v.buyoutSelf) then
					-- we can undercut, need to re-post
					type = "yellow"
				end
			end
			
			auctionInfo[recipe] = type
			numAuctionTypes[type] = numAuctionTypes[type] + 1
		end
	end
	
	-- sort auction list by name
	local sorted = {}
	for name, data in pairs(auctionInfo) do
		table.insert(sorted, name)
	end
	table.sort(sorted)
	
	-- check if we need to show previous/next-buttons
	local numPages = #sorted / 13
	
	if (numPages < self.auctionUI.page) then
		self.auctionUI.page = numPages
	end
	
	if (self.auctionUI.page > 0) then
		self.auctionUI.prevButton:Enable()
	else
		self.auctionUI.prevButton:Disable()
	end
	
	if (self.auctionUI.page < numPages - 1) then
		self.auctionUI.nextButton:Enable()
	else
		self.auctionUI.nextButton:Disable()
	end
	
	local item = 0 - self.auctionUI.page * 13
	
	for index, name in ipairs(sorted) do
		item = item + 1
		if (item > 0 and item <= 13) then
			local scrollName = self.db.profile.recipes[name].scrollName
		
			local text = self.auctionUI.items[item].name
			local money = self.auctionUI.items[item].money
			local count = self.auctionUI.items[item].count

			text:SetText(L.stripSkillName(name))
			
			if (auctionInfo[name] ~= "gray" and auctionInfo[name] ~= "red") then
				local price = self:GetMoneyText(self.list[scrollName].buyoutSelf)
				local profit = self:GetMoneyText(self.list[scrollName].buyoutSelf - self.list[scrollName].cost, true)
				
				if (self.list[scrollName].buyoutOthers) then
					money:SetText(price.." ["..profit.."; "..self:GetMoneyText(self.list[scrollName].buyoutOthers - self.list[scrollName].buyoutSelf, true).."]")
				else
					money:SetText(price.." ["..profit.."]")
				end
			else
				money:SetText("")
			end
			
			
			local ownAuctions = scrollsInAH[scrollName] or 0
			if (self.validScan) then
				count:SetText("[ "..ownAuctions.." | "..#self.list[scrollName].otherAuctions.." ]")
			else
				count:SetText("[ "..ownAuctions.." ]")
			end
			
			
			if (auctionInfo[name] == "gray") then
				text:SetTextColor(0.7, 0.7, 0.7)
				count:SetTextColor(0.7, 0.7, 0.7)
				money:SetTextColor(0.7, 0.7, 0.7)
			elseif (auctionInfo[name] == "green") then
				text:SetTextColor(0, 1, 0)
				count:SetTextColor(0, 1, 0)
				money:SetTextColor(0, 1, 0)
			elseif (auctionInfo[name] == "yellow") then
				text:SetTextColor(1, 1, 0)
				count:SetTextColor(1, 1, 0)
				money:SetTextColor(1, 1, 0)
			elseif (auctionInfo[name] == "orange") then
				text:SetTextColor(1, 0.5, 0)
				count:SetTextColor(1, 0.5, 0)
				money:SetTextColor(1, 0.5, 0)
			elseif (auctionInfo[name] == "blue") then
				text:SetTextColor(0.4, 0.4, 1)
				count:SetTextColor(0.4, 0.4, 1)
				money:SetTextColor(0.4, 0.4, 1)
			elseif (auctionInfo[name] == "red") then
				text:SetTextColor(1, 0, 0)
				count:SetTextColor(1, 0, 0)
				money:SetTextColor(1, 0, 0)
			end
		end 
	end
	
	if (item > 0 and item < 13) then
		for i = item + 1, 13 do
			self.auctionUI.items[i].name:SetText("")
			self.auctionUI.items[i].count:SetText("")
			self.auctionUI.items[i].money:SetText("")
		end
	end
	
	for k, v in pairs(numAuctionTypes) do
		if (v == 0) then
			numAuctionTypes[k] = ""
		else
			numAuctionTypes[k] = v.."x "
		end
	end
	
	self.auctionUI.grayLabel:SetText(numAuctionTypes.gray .. "unknown - need to scan")
	self.auctionUI.greenLabel:SetText(numAuctionTypes.green .. "cheapest auction")
	self.auctionUI.yellowLabel:SetText(numAuctionTypes.yellow .. "undercut - need to repost")
	self.auctionUI.orangeLabel:SetText(numAuctionTypes.orange .. "can't undercut cheapest auction")
	self.auctionUI.blueLabel:SetText(numAuctionTypes.blue .. "can repost for higher price")
	self.auctionUI.redLabel:SetText(numAuctionTypes.red .. "empty - need to restock")
end

function Capitalist:GetMoneyText(amount, sign, significantDigits)
	if (amount == nil) then
		return ""
	end
	
	local str
	
	if (abs(amount) > 10000) then
		str = "g"
		amount = amount / 10000
	elseif (abs(amount) > 100) then
		str = "s"
		amount = amount / 100
	else
		str = "c"
	end
	
	if (not significantDigits) then
		amount = math.floor(amount + 0.5)
	else
		local factor = math.pow(10, significantDigits - 1)
		amount = math.floor(amount * factor) / factor
	end
	
	
	str = amount .. str
	
	if (sign and amount > 0) then
		str = "+"..str
	end
	
	return str
end